Package io.vertx.rxjava3.core.file

## Class AsyncFile

- java.lang.Object
- - io.vertx.rxjava3.core.file.AsyncFile

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`, `ReadStream<Buffer>`, `StreamBase`, `WriteStream<Buffer>`

      public class AsyncFile
      extends Object
      implements io.vertx.lang.rx.RxDelegate, ReadStream<Buffer>, WriteStream<Buffer>

  Represents a file on the file-system which can be read from, or written to asynchronously.

  This class also implements `ReadStream` and `WriteStream`. This allows the data to be piped to and from other streams, e.g. an `HttpClientRequest` instance, using the `Pipe` class

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<AsyncFile>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AsyncFile​(AsyncFile delegate)` |
    `AsyncFile​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Completable` | `close()` | Close the file.
    `AsyncFile` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `Completable` | `end()` | Ends the stream.
    `Completable` | `end​(Buffer data)` | Same as `WriteStream.end()` but writes some data to the stream before ending.
    `AsyncFile` | `endHandler​(Handler<Void> endHandler)` | Set an end handler.
    `boolean` | `equals​(Object o)` |
    `AsyncFile` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream and on the write stream.
    `AsyncFile` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `Completable` | `flush()` | Flush any writes made to this file to underlying persistent storage.
    `AsyncFile` | `getDelegate()` |
    `long` | `getReadLength()` |
    `long` | `getWritePos()` |
    `AsyncFile` | `handler​(Handler<Buffer> handler)` | Set a data handler.
    `int` | `hashCode()` |
    `Single<AsyncFileLock>` | `lock()` | Acquire a non-shared lock on the entire file.
    `Single<AsyncFileLock>` | `lock​(long position, long size, boolean shared)` | Acquire a lock on a portion of this file.
    `static AsyncFile` | `newInstance​(AsyncFile arg)` |
    `AsyncFile` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` | Pause this stream and return a to transfer the elements of this stream to a destination .
    `Completable` | `pipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `Single<Buffer>` | `read​(Buffer buffer, int offset, long position, int length)` | Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `AsyncFile` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `Completable` | `rxClose()` | Close the file.
    `Completable` | `rxEnd()` | Ends the stream.
    `Completable` | `rxEnd​(Buffer data)` | Same as `WriteStream.end()` but writes some data to the stream before ending.
    `Completable` | `rxFlush()` | Flush any writes made to this file to underlying persistent storage.
    `Single<AsyncFileLock>` | `rxLock()` | Acquire a non-shared lock on the entire file.
    `Single<AsyncFileLock>` | `rxLock​(long position, long size, boolean shared)` | Acquire a lock on a portion of this file.
    `Completable` | `rxPipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `Single<Buffer>` | `rxRead​(Buffer buffer, int offset, long position, int length)` | Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `Single<Long>` | `rxSize()` |
    `<T> Single<T>` | `rxWithLock​(long position, long size, boolean shared, Supplier<Single<T>> block)` | Acquire a lock on a portion of this file.
    `<T> Single<T>` | `rxWithLock​(Supplier<Single<T>> block)` | Acquire a non-shared lock on the entire file.
    `Completable` | `rxWrite​(Buffer data)` | Write some data to the stream.
    `Completable` | `rxWrite​(Buffer buffer, long position)` | Write a `Buffer` to the file at position `position` in the file, asynchronously.
    `AsyncFile` | `setReadBufferSize​(int readBufferSize)` | Sets the buffer size that will be used to read the data from the file.
    `AsyncFile` | `setReadLength​(long readLength)` | Sets the number of bytes that will be read when using the file as a `ReadStream`.
    `AsyncFile` | `setReadPos​(long readPos)` | Sets the position from which data will be read from when using the file as a `ReadStream`.
    `AsyncFile` | `setWritePos​(long writePos)` | Sets the position from which data will be written when using the file as a `WriteStream`.
    `AsyncFile` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `Single<Long>` | `size()` |
    `long` | `sizeBlocking()` | Like `size()` but blocking.
    `Flowable<Buffer>` | `toFlowable()` |
    `Observable<Buffer>` | `toObservable()` |
    `WriteStreamObserver<Buffer>` | `toObserver()` |
    `String` | `toString()` |
    `WriteStreamSubscriber<Buffer>` | `toSubscriber()` |
    `AsyncFileLock` | `tryLock()` | Try to acquire a non-shared lock on the entire file.
    `AsyncFileLock` | `tryLock​(long position, long size, boolean shared)` | Try to acquire a lock on a portion of this file.
    `<T> Single<T>` | `withLock​(long position, long size, boolean shared, Supplier<Single<T>> block)` | Acquire a lock on a portion of this file.
    `<T> Single<T>` | `withLock​(Supplier<Single<T>> block)` | Acquire a non-shared lock on the entire file.
    `Completable` | `write​(Buffer data)` | Write some data to the stream.
    `Completable` | `write​(Buffer buffer, long position)` | Write a `Buffer` to the file at position `position` in the file, asynchronously.
    `boolean` | `writeQueueFull()` | This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<AsyncFile> __TYPE_ARG

  - ### Constructor Detail

    - #### AsyncFile

          public AsyncFile​(AsyncFile delegate)

    - #### AsyncFile

          public AsyncFile​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public AsyncFile getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toFlowable

          public Flowable<Buffer> toFlowable()

      Specified by:
        `toFlowable` in interface `ReadStream<Buffer>`

    - #### toObserver

          public WriteStreamObserver<Buffer> toObserver()

      Specified by:
        `toObserver` in interface `WriteStream<Buffer>`

    - #### toSubscriber

          public WriteStreamSubscriber<Buffer> toSubscriber()

      Specified by:
        `toSubscriber` in interface `WriteStream<Buffer>`

    - #### write

          public Completable write​(Buffer data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### rxWrite

          public Completable rxWrite​(Buffer data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `rxWrite` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### end

          public Completable end()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### end

          public Completable end​(Buffer data)

      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd​(Buffer data)

      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        `true` if write queue is full

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Returns:
        a pipe

    - #### pipeTo

          public Completable pipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### rxPipeTo

          public Completable rxPipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `rxPipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### handler

          public AsyncFile handler​(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public AsyncFile pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public AsyncFile resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public AsyncFile endHandler​(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public AsyncFile setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public AsyncFile drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          public AsyncFile exceptionHandler​(Handler<Throwable> handler)

      Set an exception handler on the read stream and on the write stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public AsyncFile fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### close

          public Completable close()

      Close the file. The actual close happens asynchronously.
      Returns:
        a future completed with the result

    - #### rxClose

          public Completable rxClose()

      Close the file. The actual close happens asynchronously.
      Returns:
        a future completed with the result

    - #### write

          public Completable write​(Buffer buffer,
                                   long position)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
      Returns:
        a future notified when the write is complete

    - #### rxWrite

          public Completable rxWrite​(Buffer buffer,
                                     long position)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
      Returns:
        a future notified when the write is complete

    - #### read

          public Single<Buffer> read​(Buffer buffer,
                                     int offset,
                                     long position,
                                     int length)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
      Returns:
        a future notified when the write is complete

    - #### rxRead

          public Single<Buffer> rxRead​(Buffer buffer,
                                       int offset,
                                       long position,
                                       int length)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
      Returns:
        a future notified when the write is complete

    - #### flush

          public Completable flush()

      Flush any writes made to this file to underlying persistent storage.

      If the file was opened with `flush` set to `true` then calling this method will have no effect.

      The actual flush will happen asynchronously.

      Returns:
        a future completed with the result

    - #### rxFlush

          public Completable rxFlush()

      Flush any writes made to this file to underlying persistent storage.

      If the file was opened with `flush` set to `true` then calling this method will have no effect.

      The actual flush will happen asynchronously.

      Returns:
        a future completed with the result

    - #### setReadPos

          public AsyncFile setReadPos​(long readPos)

      Sets the position from which data will be read from when using the file as a `ReadStream`.
      Parameters:
        `readPos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### setReadLength

          public AsyncFile setReadLength​(long readLength)

      Sets the number of bytes that will be read when using the file as a `ReadStream`.
      Parameters:
        `readLength` - the bytes that will be read from the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### getReadLength

          public long getReadLength()

      Returns:
        the number of bytes that will be read when using the file as a `ReadStream`

    - #### setWritePos

          public AsyncFile setWritePos​(long writePos)

      Sets the position from which data will be written when using the file as a `WriteStream`.
      Parameters:
        `writePos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### getWritePos

          public long getWritePos()

      Returns:
        the current write position the file is at

    - #### setReadBufferSize

          public AsyncFile setReadBufferSize​(int readBufferSize)

      Sets the buffer size that will be used to read the data from the file. Changing this value will impact how much the data will be read at a time from the file system.
      Parameters:
        `readBufferSize` - the buffer size
      Returns:
        a reference to this, so the API can be used fluently

    - #### sizeBlocking

          public long sizeBlocking()

      Like `size()` but blocking.
      Returns:

    - #### size

          public Single<Long> size()

      Returns:
        the size of the file

    - #### rxSize

          public Single<Long> rxSize()

      Returns:
        the size of the file

    - #### tryLock

          public AsyncFileLock tryLock()

      Try to acquire a non-shared lock on the entire file.
      Returns:
        the lock if it can be acquired immediately, otherwise `null`

    - #### tryLock

          public AsyncFileLock tryLock​(long position,
                                       long size,
                                       boolean shared)

      Try to acquire a lock on a portion of this file.
      Parameters:
        `position` - where the region starts
        `size` - the size of the region
        `shared` - whether the lock should be shared
      Returns:
        the lock if it can be acquired immediately, otherwise `null`

    - #### lock

          public Single<AsyncFileLock> lock()

      Acquire a non-shared lock on the entire file.
      Returns:
        a future indicating the completion of this operation

    - #### rxLock

          public Single<AsyncFileLock> rxLock()

      Acquire a non-shared lock on the entire file.
      Returns:
        a future indicating the completion of this operation

    - #### lock

          public Single<AsyncFileLock> lock​(long position,
                                            long size,
                                            boolean shared)

      Acquire a lock on a portion of this file.
      Parameters:
        `position` - where the region starts
        `size` - the size of the region
        `shared` - whether the lock should be shared
      Returns:
        a future indicating the completion of this operation

    - #### rxLock

          public Single<AsyncFileLock> rxLock​(long position,
                                              long size,
                                              boolean shared)

      Acquire a lock on a portion of this file.
      Parameters:
        `position` - where the region starts
        `size` - the size of the region
        `shared` - whether the lock should be shared
      Returns:
        a future indicating the completion of this operation

    - #### withLock

          public <T> Single<T> withLock​(Supplier<Single<T>> block)

      Acquire a non-shared lock on the entire file.

      When the `block` is called, the lock is already acquired, it will be released when the `Future` returned by the block completes.

      When the `block` fails, the lock is released and the returned future is failed with the cause of the failure.

      Parameters:
        `block` - the code block called after lock acquisition
      Returns:
        the future returned by the `block`

    - #### rxWithLock

          public <T> Single<T> rxWithLock​(Supplier<Single<T>> block)

      Acquire a non-shared lock on the entire file.

      When the `block` is called, the lock is already acquired, it will be released when the `Future` returned by the block completes.

      When the `block` fails, the lock is released and the returned future is failed with the cause of the failure.

      Parameters:
        `block` - the code block called after lock acquisition
      Returns:
        the future returned by the `block`

    - #### withLock

          public <T> Single<T> withLock​(long position,
                                        long size,
                                        boolean shared,
                                        Supplier<Single<T>> block)

      Acquire a lock on a portion of this file.

      When the `block` is called, the lock is already acquired , it will be released when the `Future` returned by the block completes.

      When the `block` fails, the lock is released and the returned future is failed with the cause of the failure.

      Parameters:
        `position` - where the region starts
        `size` - the size of the region
        `shared` - whether the lock should be shared
        `block` - the code block called after lock acquisition
      Returns:
        the future returned by the `block`

    - #### rxWithLock

          public <T> Single<T> rxWithLock​(long position,
                                          long size,
                                          boolean shared,
                                          Supplier<Single<T>> block)

      Acquire a lock on a portion of this file.

      When the `block` is called, the lock is already acquired , it will be released when the `Future` returned by the block completes.

      When the `block` fails, the lock is released and the returned future is failed with the cause of the failure.

      Parameters:
        `position` - where the region starts
        `size` - the size of the region
        `shared` - whether the lock should be shared
        `block` - the code block called after lock acquisition
      Returns:
        the future returned by the `block`

    - #### newInstance

          public static AsyncFile newInstance​(AsyncFile arg)